-- by modelleicher
-- 30/05/2018
-- https://www.facebook.com/Modelleicher/
-- www.ls-modcompany.de 
-- 21.11.2018 conversion to FS19
-- 02.12.2018 fixed Inputs for FS19
-- 08.12.2018 fixed bugs with growth when timescale is actually 0, its 0.0001 instead now for 0
-- 14.04.2019 max. timescale changed from 240 to 480, made ready for modhub release 


fineTimescaleAdjustment = {};
addModEventListener(fineTimescaleAdjustment);

function fineTimescaleAdjustment:loadMap(name)
	self.lastTimeScale = g_currentMission.missionInfo.timeScale;
	
	self.inputsActive = false;
end;

function fineTimescaleAdjustment:INCREASE_TIMESCALE_MOD()
	local scale = g_currentMission.missionInfo.timeScale
	
	if scale < 15 then
		scale = self.lastTimeScale + 1;
	elseif scale < 30 then
		scale = self.lastTimeScale + 5;
	elseif scale < 60 then
		scale = self.lastTimeScale + 10;
	elseif scale < 240 then
		scale = self.lastTimeScale + 20;
	else 
		scale = self.lastTimeScale + 40;
	end;
	
	scale = math.min(scale, 480)

	g_currentMission:setTimeScale(scale)
	
	self.lastTimeScale = scale;

end;

function fineTimescaleAdjustment:DECREASE_TIMESCALE_MOD()
	local scale = g_currentMission.missionInfo.timeScale
		
	if scale < 15 then
		scale = self.lastTimeScale - 1;
	elseif scale < 30 then
		scale = self.lastTimeScale - 5;
	elseif scale < 60 then
		scale = self.lastTimeScale - 10;
	elseif scale < 240 then
		scale = self.lastTimeScale - 20;
	else
		scale = self.lastTimeScale - 40;
	end;
	
	scale = math.max(scale, 0.0001)

	g_currentMission:setTimeScale(scale)
	
	self.lastTimeScale = scale;

end;


function fineTimescaleAdjustment:update(dt)
	-- Input Action Events in FS19. Apparantly you have to add them only for the duration you want them to work
	-- If I get into a vehicle of any sort it automatically resets the list. So I don't need to clear them?
	-- just add them each time you leave a vehicle basically. (g_currentMission.controlledVehicle is nil again)
	if g_currentMission:getIsClient() then -- don't run on the Dedicated Server itself
		if g_gui.currentGui == nil and g_currentMission.controlledVehicle == nil then -- only if no vehicle is entered or menu is up
			if g_currentMission:getIsServer() or g_currentMission.isMasterUser then -- only if we are the host or logged in as admin
				if not self.inputsActive then
			        local _ , eventId = g_currentMission.inputManager:registerActionEvent(InputAction.INCREASE_TIMESCALE_MOD, fineTimescaleAdjustment, fineTimescaleAdjustment.INCREASE_TIMESCALE_MOD, false, true, false, true);
					local _ , eventId2 = g_currentMission.inputManager:registerActionEvent(InputAction.DECREASE_TIMESCALE_MOD, fineTimescaleAdjustment, fineTimescaleAdjustment.DECREASE_TIMESCALE_MOD, false, true, false, true);
					self.inputsActive = true;
				end;
			end;
		else
			self.inputsActive = false;
		end;
	end;
	
end
function fineTimescaleAdjustment:deleteMap()
end;
function fineTimescaleAdjustment:draw()
end;
function fineTimescaleAdjustment:mouseEvent(posX, posY, isDown, isUp, button)
end;
function fineTimescaleAdjustment:keyEvent(unicode, sym, modifier, isDown)
end;



